Bug 215627 - mga: recursive heavyweight lock with dri
mga: recursive heavyweight lock with dri
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-mga (Show other bugs)
8
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Adam Jackson
bzcl34nup
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-11-14 16:46 EST by Martin Ebourne
Modified: 2009-01-09 02:01 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-09 02:01:10 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
strace from mythfrontend (268.81 KB, text/plain)
2006-11-14 16:46 EST, Martin Ebourne
no flags Details
X configuration file (2.20 KB, text/plain)
2006-11-22 16:48 EST, Martin Ebourne
no flags Details
Log file from X on a run where it hangs (45.45 KB, text/plain)
2006-11-22 16:49 EST, Martin Ebourne
no flags Details

  None (edit)
Description Martin Ebourne 2006-11-14 16:46:37 EST
Description of problem:
X is hanging with [drm:drm_lock_take] *ERROR* 1 holds heavyweight lock. Works
fine with DRI disabled.

Version-Release number of selected component (if applicable):
xorg-x11-drivers-7.1-3
xorg-x11-drv-mga-1.4.2-1.fc6
kernel-2.6.18-1.2798.fc6 (and others)

How reproducible:
Every time.

Steps to Reproduce:
1. Reboot
2. ratpoison and mythfrontend both start automatically on this machine
  
Actual results:
X hangs during mythtv startup. Proceeds ok if mythtv is not started. Only a kill
-9 will stop X.

Expected results:
Should not hang.

Additional info:
This has was working fine on a fully updated FC5 system, only change was upgrade
to FC6.

Video card is a Matrox G550.

From /var/log/messages:
21:28:45 kernel: [drm] Initialized mga 3.2.1 20051102 on minor 0
21:28:45 kernel: agpgart: Found an AGP 3.0 compliant device at 0000:00:00.0.
21:28:45 kernel: agpgart: Device is in legacy mode, falling back to 2.x
21:28:45 kernel: agpgart: Putting AGP V2 device at 0000:00:00.0 into 4x mode
21:28:45 kernel: agpgart: Putting AGP V2 device at 0000:01:00.0 into 4x mode
21:28:45 kernel: [drm] Initialized card for AGP DMA.
21:29:11 kernel: [drm:drm_lock_take] *ERROR* 1 holds heavyweight lock
21:29:14 last message repeated 159 times

Backtrace from hung X process:
#0  0x000000349a6c6267 in ioctl () from /lib64/libc.so.6
#1  0x00002aaaac02f987 in drmGetLock ()
   from /usr/lib64/xorg/modules/linux/libdrm.so
#2  0x00002aaaabe28f1b in DRILock ()
   from /usr/lib64/xorg/modules/extensions/libdri.so
#3  0x00002aaaabe291b2 in DRIClipNotify ()
   from /usr/lib64/xorg/modules/extensions/libdri.so
#4  0x000000000054e2e5 in compClipNotify ()
#5  0x00000000004d6ef2 in miShapedWindowIn ()
#6  0x00000000004d7660 in miValidateTree ()
#7  0x00000000004dd9cd in miMoveWindow ()
#8  0x000000000054efcb in compMoveWindow ()
#9  0x0000000000437bf6 in ConfigureWindow ()
#10 0x0000000000449516 in ProcConfigureWindow ()
#11 0x0000000000449c9a in Dispatch ()
#12 0x00000000004325d5 in main ()

A strace of the hung X process gives lots of these:
ioctl(8, 0x4008642a, 0x7fff3c2e9e40)    = ? ERESTARTSYS (To be restarted)

In case it helps I've attached the strace from mythtv as well.
Comment 1 Martin Ebourne 2006-11-14 16:46:37 EST
Created attachment 141190 [details]
strace from mythfrontend
Comment 2 Matěj Cepl 2006-11-15 05:51:14 EST
Thanks for the bug report.  We have reviewed the information you
have provided above, and there is some additional information we
require that will be helpful in our diagnosis of this issue.

Please attach your X server config file (/etc/X11/xorg.conf) and X
server log file (/var/log/Xorg.*.log) to the bug report as individual
uncompressed file attachments using the bugzilla file attachment link
below.

We will review this issue again once you've had a chance to attach
this information.

Thanks in advance.
Comment 3 Martin Ebourne 2006-11-22 16:48:23 EST
Created attachment 141947 [details]
X configuration file
Comment 4 Martin Ebourne 2006-11-22 16:49:47 EST
Created attachment 141948 [details]
Log file from X on a run where it hangs

Added xorg.conf and Xorg log with dri enabled -> X hung when mythfrontend was
starting.
Comment 5 Martin Ebourne 2006-11-22 16:51:12 EST
Still in NEEDINFO - should switch to ASSIGNED?
Comment 6 Adam Jackson 2007-02-26 17:48:07 EST
Is this still an issue with xorg-x11-drv-mga 1.4.5 ?
Comment 7 Martin Ebourne 2007-02-26 19:48:34 EST
Yep, still the same:
[drm:drm_lock_take] *ERROR* 1 holds heavyweight lock

xorg-x11-drv-mga-1.4.5-2.fc6
2.6.19-1.2911.fc6

Any ideas what's up, or what else I can try?
Comment 8 Martin Ebourne 2007-11-25 12:28:33 EST
Still broken on Fedora 8.

xorg-x11-drv-mga-1.4.6.1-6.fc8.x86_64
kernel-2.6.23.1-49.fc8.x86_64

I'd really like to track this down but have no idea where to start. Please give
me some suggestions on how to debug this.
Comment 9 Bug Zapper 2008-04-03 14:37:50 EDT
Based on the date this bug was created, it appears to have been reported
against rawhide during the development of a Fedora release that is no
longer maintained. In order to refocus our efforts as a project we are
flagging all of the open bugs for releases which are no longer
maintained. If this bug remains in NEEDINFO thirty (30) days from now,
we will automatically close it.

If you can reproduce this bug in a maintained Fedora version (7, 8, or
rawhide), please change this bug to the respective version and change
the status to ASSIGNED. (If you're unable to change the bug's version
or status, add a comment to the bug and someone will change it for you.)

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we're following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.
Comment 10 Martin Ebourne 2008-04-03 16:12:37 EDT
Hey, follow the process sure, but I already stated in comment #8 that this is
still broken in Fedora 8.
Comment 11 Bug Zapper 2008-11-26 02:05:37 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 12 Bug Zapper 2009-01-09 02:01:10 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.